<?php
/*************************************************************/
/* Responsive & Adblock killer promo 	                     */
/* Webservice file						                     */
/* URL : https://www.carpediem-sheets.com/adblock/index.html */
/* Support : philippe@carpediem.fr                           */
/*************************************************************/

require_once('includes/config.php');
require_once('includes/functions.php');

// Get geoip
$action = filter_input(INPUT_GET, 'action', FILTER_SANITIZE_STRING);
switch ( $action ) {

    case 'geoip':

        $url = 'http://geoip.securitetotale.com/geo_location_array.php';
        $inputs['ip'] = getClientIp();

        die(getRemoteFileContent($url . '?' . http_build_query($inputs)));
        exit;

        break;

}

/**
 * Filter Incoming Data
 * @param  array  $post
 * @return array
 */
function filterInput(array $post = array())
{
    $args = array(
        'tracker' => array(
            'filter' => FILTER_SANITIZE_STRING,
            'flags' => FILTER_FLAG_STRIP_LOW|FILTER_FLAG_STRIP_HIGH
        ),
        'email' => FILTER_VALIDATE_EMAIL,
        'pseudo' => array(
            'filter' => FILTER_SANITIZE_STRING,
            'flags' => FILTER_FLAG_STRIP_LOW|FILTER_FLAG_STRIP_HIGH
        ),
        'password' => array(
            'filter' => FILTER_SANITIZE_STRING,
            'flags' => FILTER_FLAG_STRIP_LOW|FILTER_FLAG_STRIP_HIGH
        ),
    );

    return array_filter(array_merge(array(
        'tracker' => '',
        'email' => false,
        'pseudo' => false,
        'password' => false,
    ), (array) filter_var_array($post, $args)));

}

/**
 * Validate Inputs
 * @param  array  $inputs
 * @return array
 */
function validateInput(array $inputs = array())
{
    $errors = array();
    if (! isset($inputs['email'])) {
        $errors['email'] = "L'adresse mail est obligatoire.";
    }

    return $errors;
}

// header('Content-type: application/json; charset=utf-8');

// Only POST datas alowed
if ('POST' != $_SERVER['REQUEST_METHOD']) {
    die(json_encode(array(
        'status' => 'errors',
        'errors' => array('method' => ' Request Method Not Supported'),
    )));
}

// Filters & validate POST datas
$inputs = filterInput($_POST);
$errors = validateInput($inputs);
if (count($errors)) {
    die(json_encode(array(
        'status' => 'errors',
        'errors' => $errors,
    )));
}

// Remote registering
$url = 'http://api.mykodial.com/user/';
$inputs['format'] = 'json';
$inputs['id'] = $config['id'];
$inputs['id_mb'] = $config['id_mb'];
$inputs['nickname'] = $inputs['pseudo'];
$inputs['ip'] = getClientIp();

$curl = curl_init();
curl_setopt_array(
    $curl,
    array(
        CURLOPT_URL => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_TIMEOUT => 10,
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => $inputs,
        CURLOPT_HTTPHEADER => array('Accept: application/json'),
        )
    );

$content = curl_exec($curl);
if (! curl_errno($curl)) {

    $data = json_decode($content, true);
    $info = curl_getinfo($curl);
    if (500 == $info['http_code']) {
        die(json_encode(array(
            'status' => 'errors',
            'errors' => array('method' => 'Request cannot be done (webservice problem)'),
        )));
    } elseif (405 == $info['http_code']) {
        die(json_encode(array(
            'status' => 'errors',
            'errors' => array('method' => 'Unvalid request'),
        )));
    } elseif (400 == $info['http_code']) {
        die(json_encode(array(
            'status' => 'errors',
            'errors' => array('email' => 'L\'adresse mail est obligatoire.'),
        )));
    } elseif (200 == $info['http_code'] && 'ok' == $data['status']) {
        die(json_encode(array(
            'status' => 'ok',
            'url' => $data['payment'],
            )));
    } else {
        die($content);
    }
    
}